"""
Set the color of your AnyBar widget.
"""

import sys
import socket


PORT = 1738
ADDRESS = 'localhost'
COLORS = ( 'white', 'red', 'orange', 'yellow', 'green', 'cyan',
           'blue', 'purple', 'black', 'question', 'exclamation' )

anybar = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)

def set_color(newcolor):
    """Set the color of the AnyBar menubar widget.

    Valid colors: {}.
    """
    if newcolor not in COLORS:
        raise ValueError("Invalid AnyBar color: {}".format(newcolor))
    anybar.sendto(newcolor.encode('utf-8'), (ADDRESS, PORT))

_quoted_list = ', '.join(["\'%s\'" % c for c in COLORS])
set_color.__doc__ = set_color.__doc__.format(_quoted_list)
