"""
Setup installation file for Spatial Phase Codes project.
"""

from setuptools import setup
from codecs import open
from os import path


here = path.abspath(path.dirname(__file__))
with open(path.join(here, 'README.md'), encoding='utf-8') as f:
    long_description = f.read()


setup(
    name='spc',
    version='1.1.3',
    description='Spatial Synchronization Codes from Coupled Rate-Phase Neurons',
    long_description=long_description,
    url='http://dx.doi.org/10.6084/m9.figshare.6072317',
    author='Joseph Monaco',
    author_email='jmonaco@jhu.edu',
    license='MIT',
    classifiers=[
        'Development Status :: 6 - Mature',
        'Intended Audience :: Science/Research',
        'Topic :: Scientific/Engineering :: Medical Science Apps.',
        'Topic :: Scientific/Engineering :: Visualization',
        'License :: OSI Approved :: MIT License',
        'Programming Language :: Python :: 3',
        'Programming Language :: Python :: 3.4'
    ],
    keywords='data model analysis LFP theta simulation neuroscience',
    packages=['spc','tenko','roto','pouty'])
