"""
SPC :: Spatial Phase Codes
Author :: Joseph Monaco (self@jdmonaco.com)
Created :: 12-15-2016
"""

__version__ = '0.1.0'

import os

from tenko.store import DataStore as _Store
from pouty.console import ConsolePrinter as _Printer


# Set up package-wide project paths and metadata

REPO_ROOT = os.path.split(__file__)[0]
PROJECT_TAG = 'spc'
PROJECT_ROOT = os.path.join(os.getenv('HOME'), 'projects', PROJECT_TAG)
DATA_ROOT = os.path.join(PROJECT_ROOT, 'data')
RES_ROOT = os.path.join(PROJECT_ROOT, 'results')
RAW_DATA_ROOT = '/Users/joe/data/blab/Theta'


# Create a package-wide data store instance for the project data file

store = _Store(name=PROJECT_TAG,
               where=DATA_ROOT,
               logfunc=_Printer(
                   prefix='{}Data'.format(PROJECT_TAG.title()),
                   prefix_color='brown',
                   message_color='lightgray'))
