"""
Factory functions for customized contexts.
"""

from .context import AnalysisContext


class ContextFactory:

    """
    Factory methods for custom context classes.
    """

    @staticmethod
    def analysis_class(classname, rootdir, repodir, resdir, logcolor='purple'):
        class _Temp(AnalysisContext):
            pass
        _Temp.rootdir = rootdir
        _Temp.repodir = repodir
        _Temp.resdir = resdir
        _Temp.logcolor = logcolor
        _Temp.__name__ = classname
        _Temp.__doc__ = AnalysisContext.__doc__
        return _Temp

    @staticmethod
    def simulation_class(classname, rootdir, repodir, resdir, logcolor='orange'):
        class _Temp(AnalysisContext):
            pass
        _Temp.rootdir = rootdir
        _Temp.repodir = repodir
        _Temp.resdir = resdir
        _Temp.logcolor = logcolor
        _Temp.__name__ = classname
        _Temp.__doc__ = AnalysisContext.__doc__
        return _Temp
