"""
Development testing for analysis context class.
"""

import matplotlib.pyplot as plt
import numpy as np
import tables as tb
from spc.ana.context import AnalysisContext, step

RUNDIR = '/Users/joe/projects/spc/output/context/63'


class ContextTest(AnalysisContext):

    """
    Test class for AnalysisContext.
    """

    @step
    def collect_data(self, param1, keyword1=10.0, keyword2=3.14, **extra):
        self.out('This is a log message...!')
        return None

    @step
    def save_some_shit(self, width, height):
        f = self.get_datafile(readonly=False)

        tbl_desc = dict(id=tb.UInt8Col(pos=0),
                        name=tb.StringCol(itemsize=8, pos=1),
                        age=tb.UInt8Col(pos=2))
        tbl = self.create_table('ages', tbl_desc, attrs={'foobar':2.3456})
        names = ['asdf', 'sdfg', 'dfgh', 'awr', 'gfds']
        for i in xrange(5):
            tbl.row['id'] = i
            tbl.row['name'] = names[i]
            tbl.row['age'] = 5 + i * 5
            tbl.row.append()

        matrix = np.random.rand(width, height)
        arr = self.save_array('arrays/rando1', matrix, attrs={'order':'first'})

        matrix = np.random.rand(width, height)
        arr = self.save_array('arrays/rando2', matrix, attrs={'order':'second'})
        grp = self.create_group('flock/of/seagulls')

    @step
    def make_figures(self, howmany=2):
        plt.ioff()
        for n in xrange(howmany):
            fig = self.figure('figures/rando', figsize=(4,4))
            ax = fig.add_subplot(111)
            ax.plot(np.random.rand(100))
            self.savefig()
        plt.ion()

    @step
    def bad_things_will_happen(self, reallybad=True):
        f = self.get_datafile()
        if reallybad:
            1/0
        rand1 = self.get_node('arrays', 'rando1')
        self.out('Found: {}', rand1)
        rand2 = self.get_node('arrays/rando2')
        self.out('Found: {}', rand2)

    @step
    def store_some_values(self, **kwargs):
        self.c.N = 100
        for key in kwargs:
            self[key] = kwargs[key]
        self.c.gamma = 52.3

    @step
    def bad_names(self):
        self['another'] = 'variable'
        self['foo_bar'] = 'whoops'
        self['seven'] = 7.0
        self.c.nothing = 'Something!'

#test = ContextTest.load(RUNDIR)
test = ContextTest(desc='here is a test')

#test.collect_data('joe', 5.0, alpha=0.5)
test.save_some_shit(64, 64)
#test.make_figures(4)
#test.close_figures()
#test.bad_things_will_happen()
test.bad_things_will_happen(False)
test.store_some_values(alpha=0.5, beta=1.3, name='joe monaco is my name')
test.store_some_values(nothing=None, false=False)
test.bad_names()

#test2 = ContextTest.load(RUNDIR)
#test2 = ContextTest.load(test._rundir)
#for key in test2:
    #print key, '=', test2[key], str(type(test2[key]))
#test2.store_some_values(alpha=1.8, sixxer='spam', hello='world', j=-1, seven=8.0)
#for key in test2:
    #print key, '=', test2[key], str(type(test2[key]))
