"""
Test attribute access to an ordered dict.
"""

from collections import OrderedDict


class AttrDict(object):

    def __init__(self, odict):
        self.__odict__ = odict

    def __getattr__(self, attr):
        return self.__odict__[attr]

    def __setattr__(self, attr, value):
        if attr == '__odict__':
            object.__setattr__(self, attr, value)
            return
        self.__odict__[attr] = value


od = OrderedDict()
ad = AttrDict(od)

ad.x = 1
ad.y = 2
print od

od['z'] = 3
print od
print ad.z

ad.z, ad.x = 4, 5
ad._beta_ = 0.63
print od
print ad._beta_
