"""
Test writing of multiple log files with ConsolePrinter.
"""

import os

from spc.output.console import ConsolePrinter


testdir = os.path.splitext(__file__)[0]
if not os.path.isdir(testdir):
    os.makedirs(testdir)


out = ConsolePrinter(prefix='LogTest', prefix_color='green', timestamp=True)

# Check opening before setting output file
out.openfile()

# Test popup
out('This is a popup message', popup=True)

# Set a file
first = os.path.join(testdir, 'first.log')
out.set_outputfile(first)

out('This is the first message')
out('-------------------------')
out('This is the second message... ;)')

out.closefile()

# Create a new file
second = os.path.join(testdir, 'second.log')
out.set_outputfile(second)

out('Yes! This message should go to the second log file!!')

out.closefile()

# Another file, but no timestamps?
third = os.path.join(testdir, 'third.log')
out.set_timestamps(False)
out.set_outputfile(third)
out('Five...')
out('Four...')
out('Three...')
out('Two...')
out('One...')
out('...')
out.closefile()

# Changing timestamping while logging multi-line messages?
fourth = os.path.join(testdir, 'fourth.log')
out.set_outputfile(fourth)
out('Now I will turn on timestamps!!')
out.set_timestamps(True)
out('This is timestamped!')
out('This is the first line\nand this is the second line\n\nand that was empty!')
#out.closefile()

# Check autoclosing previous file?
fifth = os.path.join(testdir, 'fifth.log')
out.set_outputfile(fifth)
out('I autoclosed the fourth log file!')
out.closefile()

# Try to remove a file
#out.removefile()
