"""
Test wait status message functions in parallel tools module.
"""

import numpy as np
from ipyparallel import interactive

from spc import client
from spc.output import log, debug_mode
from spc.tools.parallel import (queue_status_progress_bar,
        queue_status_progress_bar)


debug_mode(False)
ntasks = 45


@interactive
def task(task_id):
    t = np.random.randint(5, 10)
    time.sleep(t)
    return t


rc = client.get()
client.reset()
dview = rc[:]
dview.execute('import numpy as np')
dview.execute('import time')
dview.wait()

lview = rc.load_balanced_view()
res = lview.map_async(task, range(ntasks))

queue_status_progress_bar(lview, timeout=2)
times = res.get()

log('Finished {} tasks with an average of {:.2f} seconds.', ntasks,
        np.mean(times))

client.close()
debug_mode(True)
