"""
Test template.
"""

import os
import numpy as np
import matplotlib.pyplot as plt

from spc import store
from spc.lib import labels, cell
from spc.tools import maps, paths


outdir = os.path.splitext(__file__)[0]
if not os.path.isdir(outdir):
    os.makedirs(outdir)


c_id = 97
savefig = False

# --- data setup ---

rec = cell.record(c_id)
tag = labels.session_cell_id(c_id)
print 'Computing ratemaps for {}'.format(tag)

S = cell.session_for(c_id)

# --- testing ---

ratemap = S.ratemap(rec, adaptive=False, mask_occ=0.5)


# --- plotting ---

plt.ioff()

fig = plt.figure(10, (9,9))
fig.clear()
ax = fig.add_subplot(111)
maps.plot(ratemap, ax=ax, cmin=0.0, cbar=True)
ax.set_axis_off()
ax.set_title(tag)


if savefig:
    savefn = paths.uniquify(os.path.join(outdir, 'test-%04d' % c_id),
            ext='png', fmt='%s-%02d')
    plt.savefig(savefn)
    print 'Saved: {}'.format(savefn)

plt.draw()
plt.show()

